% TTR Lab session -27/03/2017- PCA - Marco Cristani

clear all
close all
load 'irisSet.mat'

%---------------------------------
% EXERCIZE 1 - the reason for PCA
%---------------------------------
% The data is 4-D so no visualization technique allows you to visualize the
% whole data. You can start trying to select some of the features and
% scattering them out in a figure.

figure; hold on
subplot(2,2,1);
scatter(X(1,:),X(2,:));
title('1-2 feats');

subplot(2,2,2);
scatter(X(3,:),X(4,:));
title('3-4 feats');

subplot(2,2,3);
scatter(X(1,:),X(3,:));
title('1-3 feats');

subplot(2,2,4);
scatter(X(1,:),X(4,:));
title('1-4 feats');

%---------------------------------
% EXERCIZE 2 - PCA
%---------------------------------
% Apply PCA on X, in order to have a set of new axis, where each one of them can be sorted 
% depending on the variance it contains

[d,N] = size(X); %number dim/feat, number points
% 1: mean
u = mean(X,2);

% 2: centering
h = ones(1,N);
B = X-u*h; % translate the points by the means

% 3: covariance matrix
C = 1/(N-1) * B*B';

% 4: eigenvalues/eigenvectors
[V,D] = eig(C);

% 5: sort eigenvalues
D=diag(D);
[D,ind]=sort(D,'descend');
V = V(:,ind); % V contains the e's organized by columns (the first column 
%               has the "largest" eigenvector and so on so forth)

% 6: selecting a single dimension (the "largest" eigenvector)
V1 = V(:,1);

% 7: projection
W = V1'*B;


% 7: plot on a single dimension
figure, scatter(W,ones(1,N))
set(gcf,'name','1D projection');

% 8: I don't trust the prof. I want to check by myself that the span over 
%    this projection line is larger than any other line, for example the x,y,z,z2 dims
figure, scatter(X(1,:),ones(1,N))
set(gcf,'name','first feature');


% Two dimensions
% 9: transform matrix
V12 = V(:,1:2);
% 10: transformation
W = V12'*B;
% 11: plot on two dimensions
figure, scatter(W(1,:),W(2,:))
set(gcf,'name','2D projection');


% Three dimensions
% 12: transform matrix
A = V(:,1:3);
% 13: transformation
Y = A'*B;
% 14: plot on three dimensions
figure, scatter3(Y(1,:),Y(2,:),Y(3,:))
set(gcf,'name','3D projection');

%---------------------------------
% EXERCIZE 2 - MANOUVERING PCA
%---------------------------------
% In order to be sure to have properly understood PCA, write down (invent) those
% 3D samples of synthetic data so that the first PCA axis is the x axis, the
% second is the z axis, the third is the y axis

X = mvnrnd([0,0,0]',[16,0,0;0,4,0;0,0,8],5000);
X = X';

[d,N] = size(X); %number dim/feat, number points
u = mean(X,2);
h = ones(1,N);
B = X-u*h; % translate the points by the means
C = 1/(N-1) * B*B';
[V,D] = eig(C);
D=diag(D);
[D,ind]=sort(D,'descend');
V = V(:,ind); 

%-------------------------------------------
% EXERCIZE 3 - Managing the overall variance
%-------------------------------------------
% Eigenvalue plot
figure;
subplot(211)
plot(D); title('Eigenvalues');
hold on;
scatter([1:d],D);

subplot(212)
y = cumsum(D)/sum(D);
plot(y); title('Modelled Information')
hold on;
scatter([1:d],y);

% Do the same analysis on the "PCAed" IRIS data




